<?php
/* appel au fichier de configuration externe */
include('config.inc.php');

/* appel au dictionnaire */
include("lang/".$lang.".inc.php");

IF (ISSET($import))
{
	IF (EREG(".",$output))
	{
		/* $output est un fichier */
		$file = FOPEN($output, "r");
		
		/* analyse 1re ligne qui doit tre de la forme <?xml... */
		$line = fgets($file,10000);
		
		IF (!EREGI("<?xml",$line))
		{
			$message=URLENCODE($strNotXMLContent);
			HEADER("Location: import.php?message=$message");
		}
		
		/* $output commence par <?xml... ; on est au dbut de la deuxime ligne */
		/* lecture de la ligne suivante */
		$line = fgets($file,10000);
		
		function IsolePremierTag($line)
		{
			/* $line est une ligne; on rcupre le premier tag qu'il soit ouvrant ou fermant */
			$void = EREGI("(<[^>^<]+>)",$line,$tag);
			return $tag[1];
		}
		
		function ContenuTag($tag)
		{
			/* $tag est un tag ouvrant ou fermant; on rcupre son contenu */
			return EREGI_REPLACE("([</>])","",$tag);
		}
		
		function remplace_apastrophe($var)
		{
			return(ereg_replace("'","\'",$var));
		} 
		
		/* on rcupre le nom de la table */
		$tag = (IsolePremierTag($line));
		$table = ContenuTag($tag);

		/* tant qu'il y a des lignes longues de 1000000 de carctres max */
		/* et que l'on pas pas trouv le nom de la table dans le dernier tag (fermant) */
		WHILE ($line = fgets($file,1000000) AND !EREG($table,$line))
		{
			/* on utilise 2 variables pour le champ et sa valeur */
			UNSET($field);
			UNSET($value);
			
			/* on enlve les espaces en dbut et fin de ligne */
			$line = trim($line);
			
			/* on rcupre le nom du champ */
			$field = ContenuTag(IsolePremierTag($line));
			/* on enlve les espaces ventuels au dbut et  la fin */
			$field = trim($field);
			/* on met le nom de ce champ dans le tableau $fields[] */
			$fields[] = $field;
			
			/* on rcupre la valeur du champ */
			/* on supprime le premier tag (ouvrant) */
			/* qui occupe (taille en caractres du champ + 2) caractres */
			$value = substr($line,strlen($field)+2);	
			
			/* le tag fermant est-il sur la mme ligne? */
			/* tant que l'on ne le rencontre pas on parcours le fichier ligne par ligne */
			WHILE (!EREGI("</".$field.">",$line) AND $line = fgets($file,1000000) AND !EREG($table,$line))
			{
				/* on passe  la ligne */
				$value .= '\n';
				/* on ajoute la ligne  la valeur du champ */
				$value .= trim($line);
			}
			
			/* on est sur la ligne qui contient le tag fermant */
			/* on supprime le tag fermant qui est </$field> */
			/* qui occupe (taille en caractres du champ + 3) caractres */
			
			$value = substr($value,0, strlen($value) - strlen($field) - 3);
			
			/* on remplace les ventuels apostrophes ' par \' */
			$value = remplace_apastrophe($value);
			
			/* on range la valeur de ce champ dans le tableau values[] */
			$values[] = $value;
		}
		FCLOSE($file);
		
		/* connexion  MySQL */
		MYSQL_CONNECT($host,$user,$pass) or die("$strAccessDenied");
		@mysql_select_db("$db") or die("$strTableNotFound");
		
		/* construction de la requte SQL */
		$query = "INSERT INTO ".$table." (";

		/* on ajoute le nom des champs */
		WHILE (LIST ($key, $field) = EACH ($fields))
		{
			$query .= $field.", ";
		}
		
		/* on supprime la dernire virgule et l'espace */
		$query = substr($query,0,strlen($query)-2);
		
		/* on continue la requte */
		$query .= ") VALUES (";
		
		/* on ajoute le contenu des champs */
		WHILE (LIST ($key, $value) = EACH ($values))
		{
			$query .= "'".$value."', ";
		}
		
		/* on supprime la dernire virgule et l'espace */
		$query = substr($query,0,strlen($query)-2);
		
		/* on ferme la requte */
		$query .= ");";

print $query;

		/* exxution de la requte */
		$result = MYSQL_QUERY($query); 
		
		/* dconnexion de MySQL */
		MYSQL_CLOSE();
	}
}
/* on envoie le message comme quoi */
$message=$strRequest;

/*
HEADER("Location: import.php?message=$massage");
*/
?>